/*
/*#
# ***************************************************************
# *                  Tabular - SIMUSOL PROYECT                  *
# *                                                             *
# *   Table extension for SIMUSOL PROYECT, for use with:        *                
# *       +  C++ Mathematical Expression Toolkit Library        *
# *          which is located in URL:                           *
# *          http://www.partow.net/programming/exprtk/index.html*
# *          used in Siru/Simusol                               *
# *       +  SCEPTRE (System for Circuit Evaluation             *
# *          and Prediction of Transient Radiation Effects)     *
# *          http://alpha.fh-friedberg.de/iem/84.html           *
# *          used in Simusol                                    *
# *   The extension was developed by                            *
# *   Diego.Saravia@ututo.org, 2016                             * 
# *   and could be used in the same terms of the toolkit        *
# *   or every free license with copyleft needed.               *
# *   http://www.simusol.org                                    *
# ***************************************************************
#
# This file is part of Tabular
#
#    Tabular is free software: you can redistribute it and/or modify
#    it under the terms of
#
#    1)the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    2) Any other free licence with copyleft recognized by the FSF
#
#    Tabular is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Tabular.  If not, see <http://www.gnu.org/licenses/>.
*/



//./interpola tanqueC.simul 0 10000 1000 TIME VCA J1
//./interpola tanqueC.simul VALOR_INICIAL VALOR_FINAL VALOR_SALTO ORDENADA VARIABLE_INTERPOLADA_1 VARIABLE_INTERPOLADA_2 ....


#define _GNU_SOURCE   // asprintf is not posix
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>
#include <limits.h>
#include <libgen.h>

#include "../src/simusol_table.h"

// put in a abs2rel.h
 char* abs2rel(const char *path,
	       const char *base,
	       char *result,
	       const size_t size);

 
 char* rel2abs(const char *path,
	       const char *base,
	       char *result,
	       const size_t size);

// finddir tambien en summapack, para sacar dependencias se copia (check lo mismo)
int finddir(char ** dir);


int finddir(char ** dire){
  char buf[300];
  char bufe[300];
  char *buf2;
  char *pc;
  char *buf3;
  char *pc2;
  if (readlink("/proc/self/exe", buf, sizeof(buf)) < 0){
        perror("readlink() error");
	exit;
  }
 else {
   pc=strdup(buf);
   buf2=dirname(pc);
   pc2=strdup(buf2);
   int nada=asprintf(dire,"%s/",dirname(pc2));
   //printf("readlink() returned '%s' for '%s'- %s\n", buf, "/proc/self/exe",*dire);
 }
} 
////////////////////////////////////////////////////////////////////////////////

int main(int argc, char *argv[]) {
    double result;   
    char *dir;
    char *gdir1 =NULL;
    char *gdir2 =NULL;

    
    unsigned int nt=0;
    //create_search_table("../data/test.txt",&nt);
    //print_table(nt);
    get_ini_tablelist();
    
    //struct table *tablex;
    
    #define MAXPATHLEN 1000
    //   char resultc[MAXPATHLEN];
    char *resultd;
        char *results;
	        char *resultc;

    char *getcwd(char *buf, size_t size); 
    //EN simusol_table con malloc
    int error1;
    int error2;
    
    char cwd[1024];
    if (getcwd(cwd, sizeof(cwd)) != NULL)
       fprintf(stdout, "Current working dir: %s\n", cwd);
    else
       perror("getcwd() error");

    //EXISTE?


    
    error1= asprintf(&resultd,"%s/%s",cwd,argv[1]);
    int error3= asprintf(&results,"%s/%s.INTER",cwd,argv[1]);
    int error4= asprintf(&resultc,"cat %s/%s.INTER",cwd,argv[1]);
    printf("path1 = %s\n", results);

  
    unsigned int ntt;
    create_search_table(resultd,&ntt);
    printf("FILE %s, nt %d\n",resultd,ntt);

    print_table(ntt);

    double final=22000.0;
    double inicial=0.0;
    double salto=100.;



    double mi, mf, ms;

  int e1= sscanf(argv[2], "%lf", &mi);
  int e2=sscanf(argv[3], "%lf", &mf);
  int e3= sscanf(argv[4], "%lf", &ms);

    
   printf("STR NUM %s %s %s \n",argv[2],argv[3], argv[4]);
  if (e1!=1 || e2!=1 || e3!=1){
    printf("No encontro numeros correctos\n");
  }
   printf("DOB NUM %s:%lf %s:%lf %s:%lf \n",argv[2], mi,argv[3], mf, argv[4], ms);

      printf("INICIAL:%lf FINAL:%lf SALTO:%lf \n", mi, mf, ms);
  FILE * fp;

      fp = fopen (results, "w+");    
    fprintf(fp,"#");
 if (argc>5){
  for(int col=5;col<argc;col++){
    fprintf(fp,"%s ",argv[col]);
  }
    fprintf(fp,"\n");
    


  
 
 
    for(double ii=mi;ii<=mf;ii+=ms){
      fprintf(fp,"%g ",ii);
      for(int col=6;col<argc;col++){
      error2=interpolate(resultd,argv[5],argv[col],ii,2, &result);
      if (error2 <0){
	printf("ERROR INTERPOLATE FILE %s %s %s\n",resultd,argv[5],argv[col] );
	       exit(error2);
               }
      fprintf(fp, " %g",result);
      }
    fprintf(fp,"\n");
    }
    //exit(0);    

    fclose (fp);


    printf("Resultados en: %s.INTER, o %s \n",argv[1], results);
    printf("\n");
    int ee=system(resultc);
 }else{
   printf("Especifique columnas y archivo en la linea de comandos\n interpola ARCHIVO.simul  col1 col2 col3\n");
 }

    exit(0);
    
    }
